## mrd6 0.9.5

=== Makefile ===
all:
	@echo "Multicast Routing daemon/framework for IPv6"
	@echo "  (c) 2004, 2005, 2006"
	@echo "         Universidade de Aveiro,"
	@echo "         Instituto de Telecomunicacoes - Polo Aveiro"

	@$(MAKE) -C src

.PHONY: config

config:
	@config/base.pl
