=== debian/changelog ===
mrd6 (0.9.6-2) unstable; urgency=low

  * New maintainer. (Closes: #572373)
  * Acknowledge NMUs. (Closes: #507211)
  * Make Makefile architecture aware (fix FTBFS on *BSD).
  * Fix FTBFS on Hurd.
  * Support status command in init script.
  * Fix lintian errors and warnings:
    - Add dependency on remote_fs in init script
    - Use invoke-rc.d in init script
    - Add a ${misc:Depends} build dependency.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Update Standards-Version to 3.8.4.
  * Bumps debhelper compatibility to 7.
    - Uses a dh based debian/rules.
  * Fix build warnings:
    - Disable strict aliasing as mrd6 violates aliasing rules
    - Avoid unnecessary libgcc dependency thanks to Pierre Habouzit
  * Deactivate watch file as upstream tarballs are no longer reachable.
  * Set Vcs-Browser and Vcs-Git fields.

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 05 May 2010 22:47:16 +0200

mrd6 (0.9.6-1.3) unstable; urgency=low

  * Non-maintainer upload.
  * add #include's in src/mrd.cpp and src/bgp/bgp.cpp to fix FTBFS.
    Thanks, James Westby for the patch.
    (Closes: #507211)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 22 Mar 2009 20:13:42 -0400

mrd6 (0.9.6-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Apply patch from upstream (r1722) to fix FTBFS on s390. Affects:
    - include/mrd/log.h
    - src/log.cpp

 -- Laurent Bigonville <bigon@debian.org>  Tue, 16 Sep 2008 19:53:14 +0200

mrd6 (0.9.6-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Apply patch from upstream to fix FBTFS on s390, mips and mipsel. Effects:
    - src/linux/mrd_components.cpp
    - src/mrd.cpp

 -- Lior Kaplan <kaplan@debian.org>  Sat, 09 Feb 2008 13:08:17 +0200

mrd6 (0.9.6-1) unstable; urgency=low

  [ Hugo Santos ]
  * New upstream release (Closes: #462786)
    - Incorporates NMU changes (Closes: #423063, #417436)
  * Now really fix FTBFS with GCC 4.3 (Closes: #455280)

  [ Lior Kaplan ]
  * Bump standards-version to 3.7.3
    - Move homepage to a regular header.
  * Fix debian-changelog-line-too-long lintian warning.
  * Fix debian-rules-ignores-make-clean-error lintain warning.
  * Add a debian version number to differentiate this package from upstream's 
    native package.

 -- Hugo Santos <hugo@fivebits.net>  Thu, 31 Jan 2008 11:51:25 +0200

mrd6 (0.9.5-rev3.dfsg-0.2) unstable; urgency=low

  * Non-maintainer upload.
  * Repackage upstream tarball to remove non-free IETF RFC/I-D (Closes: #423063)
  * Really fix FTBFS with GCC 4.3 (Closes: #417436)
  * Clean up debian/rules and create debian/{examples,manpages}

 -- Lior Kaplan <kaplan@debian.org>  Sat, 09 Jun 2007 00:57:01 +0300

mrd6 (0.9.5-rev3-0.1) unstable; urgency=low

  * Non-maintainer upload. (Closes: #418074)
  * New maintainer. (Closes: #418084)
    - Adopt this package by its upstream, which works on it very tightly with 
      Debian. Thank you Hugo for covering for an MIA maintainer.
  * New upstream release
    - Fix segfault when unloading module (Closes: #394590)
    - Fix FTBFS with GCC 4.3 (Closes: #417436)
    - New upstream address (Closes: #411805)
    - Change the package's version number inside debian, so it will be more
      accurate and easy to maintain with future (debian & upstream) versions.
  * debian/control:
    - Bump standards version to 3.7.2.2 (no changes needed)
    - Remove extra build depends, as they are covered by build-essential.
    - Update package description according to the README file.
    - Change maintainer to Hugo Santos.
  * Add watch file.

 -- Lior Kaplan <kaplan@debian.org>  Mon, 09 Apr 2007 20:28:32 +0300

mrd6 (0.9.5-release-1) unstable; urgency=low

  * New upstream release
  * Hack the version number so we can upgrade properly
  * New features:
        - update to draft 06
        - implements MSNIP and MRDISC
        - improved user-space forwarding on Linux

 -- Anand Kumria <wildfire@progsoc.org>  Sun,  8 Jan 2006 12:28:48 +1100

mrd6 (0.9.5-pre2-1) unstable; urgency=low

  * New upstream (pre)release

 -- Anand Kumria <wildfire@progsoc.org>  Mon, 28 Nov 2005 15:41:11 +1100

mrd6 (0.9.5-pre1-1) unstable; urgency=low

  * Initial upload to Debian

 -- Anand Kumria <wildfire@progsoc.org>  Tue, 15 Nov 2005 11:05:57 +1100

mrd6 (0.9.4-beta2-1) unstable; urgency=low

  * beta2

 -- Hugo Santos <hsantos@av.it.pt>  Mon, 17 Oct 2005 22:57:45 +0100

mrd6 (0.9.4-beta1-1) unstable; urgency=low

  * Bumped to 0.9.4-beta1

 -- Hugo Santos <hsantos@av.it.pt>  Wed, 28 Sep 2005 01:11:03 +0100

mrd6 (0.9.2-beta3-1) unstable; urgency=low

  * beta3

 -- Hugo Santos <hsantos@av.it.pt>  Tue, 23 Aug 2005 23:36:40 +0100

mrd6 (0.9.2-beta2-1) unstable; urgency=low

  * beta2

 -- Hugo Santos <hsantos@av.it.pt>  Thu, 18 Aug 2005 00:09:07 +0100

mrd6 (0.9.2-beta1-1) unstable; urgency=low

  * Bumped to 0.9.2.

 -- Hugo Santos <hsantos@av.it.pt>  Fri, 12 Aug 2005 00:30:29 +0100

mrd6 (0.9.1-beta2-1) unstable; urgency=low

  * Version bump

 -- Hugo Santos <hsantos@av.it.pt>  Mon, 25 Jul 2005 00:32:34 +0100

mrd6 (0.9.1-beta1-1) unstable; urgency=low

  * Version bump

 -- Hugo Santos <hsantos@av.it.pt>  Thu,  7 Jul 2005 02:34:26 +0100

mrd6 (0.9-beta2) unstable; urgency=low

  * Beta 2

 -- Hugo Santos <hsantos@av.it.pt>  Thu, 30 Jun 2005 06:19:51 +0100

mrd6 (0.9-beta1) unstable; urgency=low

  * Bump to 0.9

 -- Hugo Santos <hsantos@av.it.pt>  Sat, 25 Jun 2005 20:07:24 +0100

mrd6 (0.8.5-beta1-1) unstable; urgency=low

  * Bumped to 0.8.5

 -- Hugo Santos <hsantos@av.it.pt>  Sat, 30 Apr 2005 21:55:09 +0100

mrd6 (0.8-beta2-1) unstable; urgency=low

  * Yet another bump. 0.8-beta2

 -- Hugo Santos <hsantos@av.it.pt>  Sat, 23 Apr 2005 03:06:53 +0100

mrd6 (0.8-beta1-1) unstable; urgency=low

  * Bumped version to 0.8-beta1

 -- Hugo Santos <hsantos@av.it.pt>  Tue, 19 Apr 2005 23:34:04 +0100

mrd6 (0.7-beta3-1) unstable; urgency=low

  * Bumped version to 0.7-beta3

 -- Hugo Santos <hsantos@av.it.pt>  Tue,  5 Apr 2005 02:08:32 +0100


