=== debian/control ===
Source: mrd6
Section: net
Priority: optional
Maintainer: Thomas Preud'homme <robotux@celest.fr>
Build-Depends: debhelper (>= 7.0.50), perl
Standards-Version: 3.8.4
Homepage: http://fivebits.net/proj/mrd6/
Vcs-Browser: http://git.debian.org/?p=collab-maint/mrd6.git;a=summary
Vcs-Git: git://git.debian.org/collab-maint/mrd6.git

Package: mrd6
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
Description: IPv6 Multicast Routing Daemon
 mrd6 is a modular IPv6 Multicast Routing Daemon which implements:
   * MLDv1 and MLDv2 support
     - MLD proxying
   * PIM-SM (ASM and SSM)
     - Bootstrap (BSR) Mechanism support
     - Static RP configuration
     - Embedded-RP support (RFC 3956)
   * partial MBGP support
     - Implements basic BGP4 mechanisms (IPv6 Multicast SAFI)
       to update local MRIB from MBGP info
     - Uses IPv6 Multicast SAFI prefixes announced by
       peers to update local MRIB
     - Is able to announce local prefixes
     - Filter support
   * Supports both native and virtual (tunnel) interfaces
     (tested IPv6-IPv4, IPv6-IPv6 and TUN/TAP tunnels)
   * Abstract Forwarding Interface (MFA) with user-space module
   * Remote configuration and online administration
