=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export PREFIX=/usr
export TARGET=mrd6

DH_OVERRIDEN := dh_installcatalogs dh_installcron dh_installdebconf \
		dh_installemacsen dh_installifupdown dh_installinfo \
		dh_installmenu dh_installmime dh_installmodules \
		dh_installlogcheck dh_installlogrotate dh_installpam \
		dh_installppp dh_installudev dh_installwm \
		dh_installxfonts dh_lintian dh_gconf dh_icons dh_perl

ifneq ($(shell which dh_bugfiles),)
DH_OVERRIDEN := $(DH_OVERRIDEN) dh_bugfiles
endif

ifneq ($(shell which dh_pysupport),)
DH_OVERRIDEN := $(DH_OVERRIDEN) dh_pysupport
endif

RULE_OVERRIDE := $(patsubst %,override_%,$(DH_OVERRIDEN))

$(RULE_OVERRIDE):

override_dh_auto_configure:
	dh_auto_configure -- \
		--prefix /usr \
		--static mld \
		--static pim \
		--static console \
		--external bgp \
		--external msnip \
		--external mrdisc

everride_dh_auto_clean:
	dh_auto_clean
	rm -rf src/build/
	rm -f src/Makefile.options

build:
	dh build
	touch build

%:
	dh $@
